[libcamera-devel] [PATCH] utils: hooks: Add pre-push commit hook

Laurent Pinchart laurent.pinchart at ideasonboard.com
Thu Mar 26 12:49:20 CET 2020


Add a pre-push commit hooks to prevent unintentional push of patches
containing local changelogs to the master branch.

Signed-off-by: Laurent Pinchart <laurent.pinchart at ideasonboard.com>
---
 utils/hooks/pre-push | 59 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 59 insertions(+)
 create mode 100755 utils/hooks/pre-push

diff --git a/utils/hooks/pre-push b/utils/hooks/pre-push
new file mode 100755
index 000000000000..dc054b2553ff
--- /dev/null
+++ b/utils/hooks/pre-push
@@ -0,0 +1,59 @@
+#!/bin/sh
+
+# A hook script to verify what is about to be pushed.  Called by "git
+# push" after it has checked the remote status, but before anything has been
+# pushed.  If this script exits with a non-zero status nothing will be pushed.
+#
+# This hook is called with the following parameters:
+#
+# $1 -- Name of the remote to which the push is being done
+# $2 -- URL to which the push is being done
+#
+# If pushing without using a named remote those arguments will be equal.
+#
+# Information about the commits which are being pushed is supplied as lines to
+# the standard input in the form:
+#
+#   <local ref> <local sha1> <remote ref> <remote sha1>
+#
+# This script prevents push of commits than contain a local changelog to the
+# master branch.
+
+remote="$1"
+url="$2"
+
+z40=0000000000000000000000000000000000000000
+
+while read local_ref local_sha remote_ref remote_sha
+do
+	if [ "$remote_ref" != refs/heads/master ]
+	then
+		continue
+	fi
+
+	if [ "$local_sha" = $z40 ]
+	then
+		# Handle delete
+		:
+	else
+		if [ "$remote_sha" = $z40 ]
+		then
+			# New branch, examine all commits
+			range="$local_sha"
+		else
+			# Update to existing branch, examine new commits
+			range="$remote_sha..$local_sha"
+		fi
+
+		# Check for WIP commit
+		commit=`git rev-list -n 1 --grep '^---' "$range"`
+		if [ -n "$commit" ]
+		then
+			echo >&2 "Found local changelog in $local_ref, not pushing"
+			echo >&2 "Check commit $commit"
+			exit 1
+		fi
+	fi
+done
+
+exit 0
-- 
Regards,

Laurent Pinchart



More information about the libcamera-devel mailing list